package com.donum.accountservice.Model;

import com.amazonaws.services.dynamodbv2.datamodeling.*;
import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;

import java.io.Serializable;

@DynamoDBTable(tableName = "Users")
public class User implements Serializable {

    private static final long serialVersionUID = 1L;

    private BCryptPasswordEncoder _bCryptPasswordEncoder = new BCryptPasswordEncoder();

    private String id;
    private String accesscode;
    private String bloodGroup;
    private String firstName;
    private String lastName;
    private String Email;
    private String password;
    private String addressline;
    private String postcode;
    private String latitude;
    private String longitude;
    private boolean isVerified = false;
    private String resetPasswordToken = "";

    public User() {}

    public User(String bloodGroup, String firstname, String lastName, String email, String password, String addressline, String postcode, String latitude, String longitude) { // Proper Constructor
        this.bloodGroup = bloodGroup;
        this.firstName = firstname;
        this.lastName = lastName;
        this.Email = email;
        this.password = _bCryptPasswordEncoder.encode(password);
        this.addressline = addressline;
        this.postcode = postcode;
        this.latitude = latitude;
        this.longitude = longitude;
    }

    @DynamoDBAutoGeneratedKey
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getAccesscode() {
        return accesscode;
    }

    public void setAccesscode(String accesscode) {
        this.accesscode = accesscode;
    }

    @DynamoDBAttribute
    public String getBloodGroup() {
        return bloodGroup;
    }

    public void setBloodGroup(String bloodGroup) {
        this.bloodGroup = bloodGroup;
    }

    @DynamoDBAttribute
    public String getFirstName() {
        return firstName;
    }

    public void setFirstName(String firstName) {
        this.firstName = firstName;
    }

    @DynamoDBAttribute
    public String getLastName() {
        return lastName;
    }

    public void setLastName(String lastName) {
        this.lastName = lastName;
    }

    @DynamoDBHashKey(attributeName = "Email")
    public String getEmail() {
        return Email;
    }

    public void setEmail(String email) {
        this.Email = email;
    }

    @DynamoDBAttribute
    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = _bCryptPasswordEncoder.encode(password);
    }

    @DynamoDBAttribute
    public String getAddressline() {
        return addressline;
    }

    public void setAddressline(String addressline) {
        this.addressline = addressline;
    }

    @DynamoDBAttribute
    public String getPostcode() {
        return postcode;
    }

    public void setPostcode(String postcode) {
        this.postcode = postcode;
    }

    @DynamoDBAttribute
    public String getLatitude() {
        return latitude;
    }

    public void setLatitude(String latitude) {
        this.latitude = latitude;
    }

    @DynamoDBAttribute
    public String getLongitude() {
        return longitude;
    }

    public void setLongitude(String longitude) {
        this.longitude = longitude;
    }

    public boolean isVerified() {
        return isVerified;
    }

    public void setVerified(boolean verified) {
        isVerified = verified;
    }

    public String getResetPasswordToken() {
        return resetPasswordToken;
    }

    public void setResetPasswordToken(String resetPasswordToken) {
        this.resetPasswordToken = resetPasswordToken;
    }

    @Override
    public String toString() {
        return "User{" +
                "id='" + id + '\'' +
                ", bloodGroup='" + bloodGroup + '\'' +
                ", firstName='" + firstName + '\'' +
                ", lastName='" + lastName + '\'' +
                ", Email='" + Email + '\'' +
                ", password='" + password + '\'' +
                ", addressline='" + addressline + '\'' +
                ", postcode='" + postcode + '\'' +
                ", latitude='" + latitude + '\'' +
                ", longitude='" + longitude + '\'' +
                '}';
    }
}
